﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using CustomComponents.Exceptions;

namespace KOP_Labs
{
    public partial class CustomComboBox : UserControl
    {
        public CustomComboBox()
        {
            InitializeComponent();
        }

        public int? MinValue { get; set; }
        public int? MaxValue { get; set; }

        private EventHandler _changeEvent;

        public event EventHandler ChangeEvent
        {
            add
            {
                _changeEvent += value;
            }
            remove
            {
                _changeEvent -= value;
            }

        }
        private void textBox_TextChanged(object sender, EventArgs e)
        {
            _changeEvent?.Invoke(sender, e);
            if (MinValue != null && MaxValue != null)
            {
                if (textBox.Text.Length < MinValue || textBox.Text.Length > MaxValue)
                {
                    textBox.ForeColor = Color.Red;
                }
                else
                {
                    textBox.ForeColor = Color.Green;
                }
            }

        }

        public string TextBoxValue
        {
            get
            {
                if (MinValue == null && MaxValue == null)
                {
                    throw new NoBordersException("Диапазон не задан.");
                }
                if (textBox.Text.Length >= MinValue && textBox.Text.Length <= MaxValue)
                {
                    return textBox.Text;
                }
                throw new NoBordersException("Введенное значение не входит в диапазон.");

            }
            set
            {
                if (MinValue != null && MaxValue != null)
                {
                    if (value.Length >= MinValue && value.Length <= MaxValue)
                    {
                        textBox.Text = value;
                    }
                }
            }
        }

    }
}
